Index: graphics/templates/goflow/graphics/graph.html
===================================================================
--- graphics/templates/goflow/graphics/graph.html	(revision 176)
+++ graphics/templates/goflow/graphics/graph.html	(working copy)
@@ -10,7 +10,7 @@
 {{ v.image.graphic|safe }}
 {% endfor %}
 
-<form method=get action=save>
+<form method=get action=save>{% csrf_token %}
 <input type=hidden name=image1_x><input type=hidden name=image1_y>
 <input type=submit name=action value=Save>
 </form>
Index: apptools/templates/admin/workflow/application/change_form.html
===================================================================
--- apptools/templates/admin/workflow/application/change_form.html	(revision 176)
+++ apptools/templates/admin/workflow/application/change_form.html	(working copy)
@@ -29,7 +29,7 @@
   </ul>
 {% endif %}{% endif %}
 {% endblock %}
-<form {% if has_file_field %}enctype="multipart/form-data" {% endif %}action="{{ form_url }}" method="post" id="{{ opts.module_name }}_form">{% block form_top %}{% endblock %}
+<form {% if has_file_field %}enctype="multipart/form-data" {% endif %}action="{{ form_url }}" method="post" id="{{ opts.module_name }}_form">{% csrf_token %}{% block form_top %}{% endblock %}
 <div>
 {% if is_popup %}<input type="hidden" name="_popup" value="1" />{% endif %}
 {% if save_on_top %}{% submit_row %}{% endif %}
Index: apptools/templates/admin/workflow/pushapplication/change_form.html
===================================================================
--- apptools/templates/admin/workflow/pushapplication/change_form.html	(revision 176)
+++ apptools/templates/admin/workflow/pushapplication/change_form.html	(working copy)
@@ -29,7 +29,7 @@
   </ul>
 {% endif %}{% endif %}
 {% endblock %}
-<form {% if has_file_field %}enctype="multipart/form-data" {% endif %}action="{{ form_url }}" method="post" id="{{ opts.module_name }}_form">{% block form_top %}{% endblock %}
+<form {% if has_file_field %}enctype="multipart/form-data" {% endif %}action="{{ form_url }}" method="post" id="{{ opts.module_name }}_form">{% csrf_token %}{% block form_top %}{% endblock %}
 <div>
 {% if is_popup %}<input type="hidden" name="_popup" value="1" />{% endif %}
 {% if save_on_top %}{% submit_row %}{% endif %}
Index: apptools/templates/goflow/test_start.html
===================================================================
--- apptools/templates/goflow/test_start.html	(revision 176)
+++ apptools/templates/goflow/test_start.html	(working copy)
@@ -2,7 +2,7 @@
 
 {% block content %}
 <h1>Create test workflow instances</h1>
-<form method="post">
+<form method="post">{% csrf_token %}
 <table>
 {{ form }}
 </table>
Index: apptools/templates/goflow/view_application.html
===================================================================
--- apptools/templates/goflow/view_application.html	(revision 176)
+++ apptools/templates/goflow/view_application.html	(working copy)
@@ -33,7 +33,7 @@
 
 
 {% block content_form %}
-<form method="post">
+<form method="post">{% csrf_token %}
 
 	{% block buttons_form %}
 	{% for value in ok_values %}
Index: apptools/templates/goflow/start_proto.html
===================================================================
--- apptools/templates/goflow/start_proto.html	(revision 176)
+++ apptools/templates/goflow/start_proto.html	(working copy)
@@ -19,7 +19,7 @@
 <li> a text field that you should use to enter comments; these will be logged in the history.
 <li> as many submit buttons as outer transitions with conditions.
 </ul>
-<form method="post">
+<form method="post">{% csrf_token %}
 <table>
 {{ form }}
 </table>
Index: apptools/templates/goflow/start_application.html
===================================================================
--- apptools/templates/goflow/start_application.html	(revision 176)
+++ apptools/templates/goflow/start_application.html	(working copy)
@@ -34,7 +34,7 @@
 	{% else %}
 		<form method="post">
 	{% endif %}
-	
+	{% csrf_token %}
 	{% load apptools_lib %}
 	{% form_ext form %}
 	
Index: apptools/templates/goflow/default_app.html
===================================================================
--- apptools/templates/goflow/default_app.html	(revision 176)
+++ apptools/templates/goflow/default_app.html	(working copy)
@@ -16,7 +16,7 @@
 (The instance history allows to test and debug the workflow)
 <pre>{{history}}</pre>
 <h3>Add comments in history</h3>
-<form method="post">
+<form method="post">{% csrf_token %}
 <table>
 {{ form }}
 </table>
Index: apptools/templates/goflow/edit_model.html
===================================================================
--- apptools/templates/goflow/edit_model.html	(revision 176)
+++ apptools/templates/goflow/edit_model.html	(working copy)
@@ -44,7 +44,7 @@
 		{% else %}
 		<form method="post">
 		{% endif %}
-			
+			{% csrf_token %}
 			{% load apptools_lib %}
 			{% form_ext form %}
 		
Index: graphics2/templates/admin/graphics2/processimage/change_form.html
===================================================================
--- graphics2/templates/admin/graphics2/processimage/change_form.html	(revision 176)
+++ graphics2/templates/admin/graphics2/processimage/change_form.html	(working copy)
@@ -22,7 +22,7 @@
   </ul>
 {% endif %}{% endif %}
 {% endblock %}
-<form {% if has_file_field %}enctype="multipart/form-data" {% endif %}action="{{ form_url }}" method="post" id="{{ opts.module_name }}_form">{% block form_top %}{% endblock %}
+<form {% if has_file_field %}enctype="multipart/form-data" {% endif %}action="{{ form_url }}" method="post" id="{{ opts.module_name }}_form">{% csrf_token %}{% block form_top %}{% endblock %}
 <div>
 {% if is_popup %}<input type="hidden" name="_popup" value="1" />{% endif %}
 {% if opts.admin.save_on_top %}{% submit_row %}{% endif %}
@@ -71,13 +71,13 @@
 <div id="content-main" class=module>
 <h2>Positioning activities in the process graph image</h2>
 
-<form method=get action="pos_activity">
+<form method='get' action="pos_activity">
 <table>
 <tr>
 <td>
 Select an activity then click on its symbol in the image.
 <br>
-<select name=activity>
+<select name='activity'>{% csrf_token %}
 {% for a in original.list_activities %}
 <option value="{{ a.id }}">{{ a.title }}</option>
 {% endfor %}
Index: workflow/templates/admin/workflow/application/change_form.html
===================================================================
--- workflow/templates/admin/workflow/application/change_form.html	(revision 176)
+++ workflow/templates/admin/workflow/application/change_form.html	(working copy)
@@ -29,7 +29,7 @@
   </ul>
 {% endif %}{% endif %}
 {% endblock %}
-<form {% if has_file_field %}enctype="multipart/form-data" {% endif %}action="{{ form_url }}" method="post" id="{{ opts.module_name }}_form">{% block form_top %}{% endblock %}
+<form {% if has_file_field %}enctype="multipart/form-data" {% endif %}action="{{ form_url }}" method="post" id="{{ opts.module_name }}_form">{% csrf_token %}{% block form_top %}{% endblock %}
 <div>
 {% if is_popup %}<input type="hidden" name="_popup" value="1" />{% endif %}
 {% if save_on_top %}{% submit_row %}{% endif %}
Index: workflow/templates/admin/workflow/pushapplication/change_form.html
===================================================================
--- workflow/templates/admin/workflow/pushapplication/change_form.html	(revision 176)
+++ workflow/templates/admin/workflow/pushapplication/change_form.html	(working copy)
@@ -29,7 +29,7 @@
   </ul>
 {% endif %}{% endif %}
 {% endblock %}
-<form {% if has_file_field %}enctype="multipart/form-data" {% endif %}action="{{ form_url }}" method="post" id="{{ opts.module_name }}_form">{% block form_top %}{% endblock %}
+<form {% if has_file_field %}enctype="multipart/form-data" {% endif %}action="{{ form_url }}" method="post" id="{{ opts.module_name }}_form">{% csrf_token %}{% block form_top %}{% endblock %}
 <div>
 {% if is_popup %}<input type="hidden" name="_popup" value="1" />{% endif %}
 {% if save_on_top %}{% submit_row %}{% endif %}
Index: workflow/templates/goflow/login.html
===================================================================
--- workflow/templates/goflow/login.html	(revision 176)
+++ workflow/templates/goflow/login.html	(working copy)
@@ -17,7 +17,7 @@
 <p class="errornote">{{ error_message }}</p>
 {% endif %}
 <div id="content-main">
-<form action="{{ app_path }}" method="post" id="login-form">
+<form action="{{ app_path }}" method="post" id="login-form">{% csrf_token %}
   <div class="form-row">
     <label for="id_username">{% trans 'Username:' %}</label> <input type="text" name="username" id="id_username" />
   </div>